<!DOCTYPE HTML>
<html lang="es">
<head>
<!-- Generated by javadoc (20) on Thu Apr 27 09:20:17 CEST 2023 -->
<title>FileController</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2023-04-27">
<meta name="description" content="declaration: package: com.eoi.springwebsecurity.filemanagement.controllers, class: FileController">
<meta name="generator" content="javadoc/ClassWriterImpl">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../script-dir/jquery-ui.min.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../script-dir/jquery-3.6.1.min.js"></script>
<script type="text/javascript" src="../../../../../script-dir/jquery-ui.min.js"></script>
</head>
<body class="class-declaration-page">
<script type="text/javascript">var pathtoroot = "../../../../../";
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<div class="flex-box">
<header role="banner" class="flex-header">
<nav role="navigation">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="top-nav" id="navbar-top"><button id="navbar-toggle-button" aria-controls="navbar-top" aria-expanded="false" aria-label="Toggle navigation links"><span class="nav-bar-toggle-icon">&nbsp;</span><span class="nav-bar-toggle-icon">&nbsp;</span><span class="nav-bar-toggle-icon">&nbsp;</span></button>
<div class="skip-nav"><a href="#skip-navbar-top" title="Skip navigation links">Skip navigation links</a></div>
<ul id="navbar-top-firstrow" class="nav-list" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="nav-bar-cell1-rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html#class">Help</a></li>
</ul>
<ul class="sub-nav-list-small">
<li>
<p>Summary:</p>
<ul>
<li>Nested</li>
<li><a href="#field-summary">Field</a></li>
<li><a href="#constructor-summary">Constr</a></li>
<li><a href="#method-summary">Method</a></li>
</ul>
</li>
<li>
<p>Detail:</p>
<ul>
<li><a href="#field-detail">Field</a></li>
<li><a href="#constructor-detail">Constr</a></li>
<li><a href="#method-detail">Method</a></li>
</ul>
</li>
</ul>
</div>
<div class="sub-nav">
<div id="navbar-sub-list">
<ul class="sub-nav-list">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field-summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor-summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method-summary">Method</a></li>
</ul>
<ul class="sub-nav-list">
<li>Detail:&nbsp;</li>
<li><a href="#field-detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor-detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method-detail">Method</a></li>
</ul>
</div>
<div class="nav-list-search"><a href="../../../../../search.html">SEARCH</a>
<input type="text" id="search-input" disabled placeholder="Search">
<input type="reset" id="reset-button" disabled value="reset">
</div>
</div>
<!-- ========= END OF TOP NAVBAR ========= -->
<span class="skip-nav" id="skip-navbar-top"></span></nav>
</header>
<div class="flex-content">
<main role="main">
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="sub-title"><span class="package-label-in-type">Package</span>&nbsp;<a href="package-summary.html">com.eoi.springwebsecurity.filemanagement.controllers</a></div>
<h1 title="Class FileController" class="title">Class FileController</h1>
</div>
<div class="inheritance" title="Inheritance Tree"><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html" title="class or interface in java.lang" class="external-link">java.lang.Object</a>
<div class="inheritance">com.eoi.springwebsecurity.filemanagement.controllers.FileController</div>
</div>
<section class="class-description" id="class-description">
<hr>
<div class="type-signature"><span class="annotations">@Controller
@CrossOrigin("http://localhost:8080")
</span><span class="modifiers">public class </span><span class="element-name type-name-label">FileController</span>
<span class="extends-implements">extends <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html" title="class or interface in java.lang" class="external-link">Object</a></span></div>
<div class="block">Controlador encargado de manejar la carga de archivos.
 La clase utiliza las anotaciones @Controller y @CrossOrigin para definir que es un controlador de Spring y
 permitir solicitudes CORS desde el servidor web localhost en el puerto 8080.
 La clase utiliza la inyección de dependencias (@Autowired) para acceder a los servicios necesarios para la carga
 y almacenamiento de archivos, así como para el acceso a la base de datos de archivos.</div>
</section>
<section class="summary">
<ul class="summary-list">
<!-- =========== FIELD SUMMARY =========== -->
<li>
<section class="field-summary" id="field-summary">
<h2>Field Summary</h2>
<div class="caption"><span>Fields</span></div>
<div class="summary-table three-column-summary">
<div class="table-header col-first">Modifier and Type</div>
<div class="table-header col-second">Field</div>
<div class="table-header col-last">Description</div>
<div class="col-first even-row-color"><code>private <a href="../services/DBFileStorageService.html" title="class in com.eoi.springwebsecurity.filemanagement.services">DBFileStorageService</a></code></div>
<div class="col-second even-row-color"><code><a href="#dbFileStorageService" class="member-name-link">dbFileStorageService</a></code></div>
<div class="col-last even-row-color">
<div class="block">Servicio de almacenamiento de archivos en la base de datos utilizado por el controlador.</div>
</div>
<div class="col-first odd-row-color"><code>private <a href="../services/FileSystemStorageService.html" title="interface in com.eoi.springwebsecurity.filemanagement.services">FileSystemStorageService</a></code></div>
<div class="col-second odd-row-color"><code><a href="#storageService" class="member-name-link">storageService</a></code></div>
<div class="col-last odd-row-color">
<div class="block">Servicio de almacenamiento de archivos utilizado por el controlador.</div>
</div>
<div class="col-first even-row-color"><code>private <a href="../../security/service/UserService.html" title="interface in com.eoi.springwebsecurity.security.service">UserService</a></code></div>
<div class="col-second even-row-color"><code><a href="#userService" class="member-name-link">userService</a></code></div>
<div class="col-last even-row-color">
<div class="block">Servicio de usuario utilizado por el controlador.</div>
</div>
</div>
</section>
</li>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<li>
<section class="constructor-summary" id="constructor-summary">
<h2>Constructor Summary</h2>
<div class="caption"><span>Constructors</span></div>
<div class="summary-table two-column-summary">
<div class="table-header col-first">Constructor</div>
<div class="table-header col-last">Description</div>
<div class="col-constructor-name even-row-color"><code><a href="#%3Cinit%3E(com.eoi.springwebsecurity.filemanagement.services.FileSystemStorageService)" class="member-name-link">FileController</a><wbr>(<a href="../services/FileSystemStorageService.html" title="interface in com.eoi.springwebsecurity.filemanagement.services">FileSystemStorageService</a>&nbsp;storageService)</code></div>
<div class="col-last even-row-color">
<div class="block">Constructor de la clase que recibe el servicio de almacenamiento de archivos como parámetro.</div>
</div>
</div>
</section>
</li>
<!-- ========== METHOD SUMMARY =========== -->
<li>
<section class="method-summary" id="method-summary">
<h2>Method Summary</h2>
<div id="method-summary-table">
<div class="table-tabs" role="tablist" aria-orientation="horizontal"><button id="method-summary-table-tab0" role="tab" aria-selected="true" aria-controls="method-summary-table.tabpanel" tabindex="0" onkeydown="switchTab(event)" onclick="show('method-summary-table', 'method-summary-table', 3)" class="active-table-tab">All Methods</button><button id="method-summary-table-tab2" role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" onclick="show('method-summary-table', 'method-summary-table-tab2', 3)" class="table-tab">Instance Methods</button><button id="method-summary-table-tab4" role="tab" aria-selected="false" aria-controls="method-summary-table.tabpanel" tabindex="-1" onkeydown="switchTab(event)" onclick="show('method-summary-table', 'method-summary-table-tab4', 3)" class="table-tab">Concrete Methods</button></div>
<div id="method-summary-table.tabpanel" role="tabpanel">
<div class="summary-table three-column-summary" aria-labelledby="method-summary-table-tab0">
<div class="table-header col-first">Modifier and Type</div>
<div class="table-header col-second">Method</div>
<div class="table-header col-last">Description</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#deleteFileDB(java.lang.String)" class="member-name-link">deleteFileDB</a><wbr>(<a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;id)</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Método que elimina un archivo de la base de datos a través de su identificador.</div>
</div>
<div class="col-first odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code>org.springframework.http.ResponseEntity&lt;byte[]&gt;</code></div>
<div class="col-second odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#getDatabaseFile(java.lang.String)" class="member-name-link">getDatabaseFile</a><wbr>(<a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;id)</code></div>
<div class="col-last odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Método que se encarga de obtener el archivo de la base de datos con el id proporcionado.</div>
</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#handleFileUpload(org.springframework.web.multipart.MultipartFile,org.springframework.web.servlet.mvc.support.RedirectAttributes)" class="member-name-link">handleFileUpload</a><wbr>(org.springframework.web.multipart.MultipartFile&nbsp;file,
 org.springframework.web.servlet.mvc.support.RedirectAttributes&nbsp;redirectAttributes)</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Método que se encarga de manejar la subida de un archivo al servidor.</div>
</div>
<div class="col-first odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code>org.springframework.http.ResponseEntity&lt;?&gt;</code></div>
<div class="col-second odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#handleStorageFileNotFound(java.io.FileNotFoundException)" class="member-name-link">handleStorageFileNotFound</a><wbr>(<a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/io/FileNotFoundException.html" title="class or interface in java.io" class="external-link">FileNotFoundException</a>&nbsp;exc)</code></div>
<div class="col-last odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Controlador de excepción para la excepción FileNotFoundException.</div>
</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#handleUserFileUpload(org.springframework.web.multipart.MultipartFile,org.springframework.web.servlet.mvc.support.RedirectAttributes,org.springframework.security.core.Authentication)" class="member-name-link">handleUserFileUpload</a><wbr>(org.springframework.web.multipart.MultipartFile&nbsp;file,
 org.springframework.web.servlet.mvc.support.RedirectAttributes&nbsp;redirectAttributes,
 org.springframework.security.core.Authentication&nbsp;authentication)</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Método que se encarga de manejar la subida de un archivo de usuario al servidor.</div>
</div>
<div class="col-first odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></code></div>
<div class="col-second odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#listAllUploadedFiles(org.springframework.ui.Model)" class="member-name-link">listAllUploadedFiles</a><wbr>(org.springframework.ui.Model&nbsp;model)</code></div>
<div class="col-last odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Método que se encarga de listar los archivos que han sido subidos al servidor.</div>
</div>
<div class="col-first even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code>org.springframework.http.ResponseEntity&lt;org.springframework.core.io.Resource&gt;</code></div>
<div class="col-second even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#serveFile(java.lang.String)" class="member-name-link">serveFile</a><wbr>(<a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;filename)</code></div>
<div class="col-last even-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Método que se encarga de descargar un archivo desde el servidor.</div>
</div>
<div class="col-first odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></code></div>
<div class="col-second odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4"><code><a href="#uploadFile(org.springframework.web.multipart.MultipartFile,org.springframework.web.servlet.mvc.support.RedirectAttributes,org.springframework.security.core.Authentication)" class="member-name-link">uploadFile</a><wbr>(org.springframework.web.multipart.MultipartFile&nbsp;file,
 org.springframework.web.servlet.mvc.support.RedirectAttributes&nbsp;redirectAttributes,
 org.springframework.security.core.Authentication&nbsp;authentication)</code></div>
<div class="col-last odd-row-color method-summary-table method-summary-table-tab2 method-summary-table-tab4">
<div class="block">Método que recibe una solicitud POST para cargar un archivo a la base de datos.</div>
</div>
</div>
</div>
</div>
<div class="inherited-list">
<h3 id="methods-inherited-from-class-java.lang.Object">Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html" title="class or interface in java.lang" class="external-link">Object</a></h3>
<code><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#clone()" title="class or interface in java.lang" class="external-link">clone</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang" class="external-link">equals</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#finalize()" title="class or interface in java.lang" class="external-link">finalize</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#getClass()" title="class or interface in java.lang" class="external-link">getClass</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#hashCode()" title="class or interface in java.lang" class="external-link">hashCode</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#notify()" title="class or interface in java.lang" class="external-link">notify</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#notifyAll()" title="class or interface in java.lang" class="external-link">notifyAll</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#toString()" title="class or interface in java.lang" class="external-link">toString</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#wait()" title="class or interface in java.lang" class="external-link">wait</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#wait(long)" title="class or interface in java.lang" class="external-link">wait</a>, <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/Object.html#wait(long,int)" title="class or interface in java.lang" class="external-link">wait</a></code></div>
</section>
</li>
</ul>
</section>
<section class="details">
<ul class="details-list">
<!-- ============ FIELD DETAIL =========== -->
<li>
<section class="field-details" id="field-detail">
<h2>Field Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="storageService">
<h3>storageService</h3>
<div class="member-signature"><span class="annotations">@Autowired
</span><span class="modifiers">private</span>&nbsp;<span class="return-type"><a href="../services/FileSystemStorageService.html" title="interface in com.eoi.springwebsecurity.filemanagement.services">FileSystemStorageService</a></span>&nbsp;<span class="element-name">storageService</span></div>
<div class="block">Servicio de almacenamiento de archivos utilizado por el controlador.</div>
</section>
</li>
<li>
<section class="detail" id="dbFileStorageService">
<h3>dbFileStorageService</h3>
<div class="member-signature"><span class="annotations">@Autowired
</span><span class="modifiers">private</span>&nbsp;<span class="return-type"><a href="../services/DBFileStorageService.html" title="class in com.eoi.springwebsecurity.filemanagement.services">DBFileStorageService</a></span>&nbsp;<span class="element-name">dbFileStorageService</span></div>
<div class="block">Servicio de almacenamiento de archivos en la base de datos utilizado por el controlador.</div>
</section>
</li>
<li>
<section class="detail" id="userService">
<h3>userService</h3>
<div class="member-signature"><span class="annotations">@Autowired
</span><span class="modifiers">private</span>&nbsp;<span class="return-type"><a href="../../security/service/UserService.html" title="interface in com.eoi.springwebsecurity.security.service">UserService</a></span>&nbsp;<span class="element-name">userService</span></div>
<div class="block">Servicio de usuario utilizado por el controlador.</div>
</section>
</li>
</ul>
</section>
</li>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<li>
<section class="constructor-details" id="constructor-detail">
<h2>Constructor Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="&lt;init&gt;(com.eoi.springwebsecurity.filemanagement.services.FileSystemStorageService)">
<h3>FileController</h3>
<div class="member-signature"><span class="annotations">@Autowired
</span><span class="modifiers">public</span>&nbsp;<span class="element-name">FileController</span><wbr><span class="parameters">(<a href="../services/FileSystemStorageService.html" title="interface in com.eoi.springwebsecurity.filemanagement.services">FileSystemStorageService</a>&nbsp;storageService)</span></div>
<div class="block">Constructor de la clase que recibe el servicio de almacenamiento de archivos como parámetro.
 La anotación @Autowired se utiliza para inyectar automáticamente el servicio necesario al crear una instancia de la clase.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>storageService</code> - el servicio de almacenamiento de archivos a utilizar</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
<!-- ============ METHOD DETAIL ========== -->
<li>
<section class="method-details" id="method-detail">
<h2>Method Details</h2>
<ul class="member-list">
<li>
<section class="detail" id="listAllUploadedFiles(org.springframework.ui.Model)">
<h3>listAllUploadedFiles</h3>
<div class="member-signature"><span class="annotations">@GetMapping("/files")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></span>&nbsp;<span class="element-name">listAllUploadedFiles</span><wbr><span class="parameters">(org.springframework.ui.Model&nbsp;model)</span>
                            throws <span class="exceptions"><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/io/IOException.html" title="class or interface in java.io" class="external-link">IOException</a></span></div>
<div class="block">Método que se encarga de listar los archivos que han sido subidos al servidor.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>model</code> - el modelo que se va a utilizar para pasar los datos a la vista</dd>
<dt>Returns:</dt>
<dd>el nombre de la vista a la que se va a redirigir</dd>
<dt>Throws:</dt>
<dd><code><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/io/IOException.html" title="class or interface in java.io" class="external-link">IOException</a></code> - si ocurre un error al cargar los archivos</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="serveFile(java.lang.String)">
<h3>serveFile</h3>
<div class="member-signature"><span class="annotations">@GetMapping("/files/{filename:.+}")
@ResponseBody
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">org.springframework.http.ResponseEntity&lt;org.springframework.core.io.Resource&gt;</span>&nbsp;<span class="element-name">serveFile</span><wbr><span class="parameters">(@PathVariable
 <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;filename)</span></div>
<div class="block">Método que se encarga de descargar un archivo desde el servidor.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>filename</code> - el nombre del archivo que se va a descargar</dd>
<dt>Returns:</dt>
<dd>una respuesta HTTP con el archivo a descargar en el cuerpo de la respuesta '@GetMapping("/files/{filename:.+}")' es una anotación utilizada en un método dentro de un controlador de Spring MVC que indica que el método manejará solicitudes GET para una URL que incluya una variable de ruta {filename}. El . + en la variable de ruta indica que la variable puede contener un punto y cualquier otro carácter después de él. Esto es necesario porque algunos nombres de archivo pueden contener puntos en su nombre y la expresión regular predeterminada utilizada por Spring no permitiría estos caracteres. Por ejemplo, si la URL solicitada es /files/myfile.txt, la variable de ruta {filename} será igual a myfile.txt. Si la URL solicitada es /files/myfile.pdf, la variable de ruta {filename} también será igual a myfile.pdf.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="handleFileUpload(org.springframework.web.multipart.MultipartFile,org.springframework.web.servlet.mvc.support.RedirectAttributes)">
<h3>handleFileUpload</h3>
<div class="member-signature"><span class="annotations">@PostMapping("/uploadToFileSystem")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></span>&nbsp;<span class="element-name">handleFileUpload</span><wbr><span class="parameters">(@RequestParam("file")
 org.springframework.web.multipart.MultipartFile&nbsp;file,
 org.springframework.web.servlet.mvc.support.RedirectAttributes&nbsp;redirectAttributes)</span></div>
<div class="block">Método que se encarga de manejar la subida de un archivo al servidor.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>file</code> - el archivo que se va a subir</dd>
<dd><code>redirectAttributes</code> - los atributos que se van a utilizar para pasar información entre solicitudes</dd>
<dt>Returns:</dt>
<dd>el nombre de la vista a la que se va a redirigir</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="uploadFile(org.springframework.web.multipart.MultipartFile,org.springframework.web.servlet.mvc.support.RedirectAttributes,org.springframework.security.core.Authentication)">
<h3>uploadFile</h3>
<div class="member-signature"><span class="annotations">@PostMapping("/uploadToDatabase")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></span>&nbsp;<span class="element-name">uploadFile</span><wbr><span class="parameters">(@RequestParam("file")
 org.springframework.web.multipart.MultipartFile&nbsp;file,
 org.springframework.web.servlet.mvc.support.RedirectAttributes&nbsp;redirectAttributes,
 org.springframework.security.core.Authentication&nbsp;authentication)</span></div>
<div class="block">Método que recibe una solicitud POST para cargar un archivo a la base de datos.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>file</code> - el archivo cargado en el formulario</dd>
<dd><code>redirectAttributes</code> - objeto utilizado para agregar atributos a la redirección</dd>
<dd><code>authentication</code> - objeto que representa la información de autenticación del usuario que realiza la solicitud</dd>
<dt>Returns:</dt>
<dd>una cadena de texto con la vista redirigida</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="handleUserFileUpload(org.springframework.web.multipart.MultipartFile,org.springframework.web.servlet.mvc.support.RedirectAttributes,org.springframework.security.core.Authentication)">
<h3>handleUserFileUpload</h3>
<div class="member-signature"><span class="annotations">@PostMapping("/uploadUserFileToFileSystem")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></span>&nbsp;<span class="element-name">handleUserFileUpload</span><wbr><span class="parameters">(@RequestParam("file")
 org.springframework.web.multipart.MultipartFile&nbsp;file,
 org.springframework.web.servlet.mvc.support.RedirectAttributes&nbsp;redirectAttributes,
 org.springframework.security.core.Authentication&nbsp;authentication)</span></div>
<div class="block">Método que se encarga de manejar la subida de un archivo de usuario al servidor.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>file</code> - el archivo que se va a subir</dd>
<dd><code>redirectAttributes</code> - los atributos que se van a utilizar para pasar información entre solicitudes</dd>
<dd><code>authentication</code> - la información de autenticación del usuario que está realizando la solicitud</dd>
<dt>Returns:</dt>
<dd>el nombre de la vista a la que se va a redirigir</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="getDatabaseFile(java.lang.String)">
<h3>getDatabaseFile</h3>
<div class="member-signature"><span class="annotations">@GetMapping("/databasefiles/{id}")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">org.springframework.http.ResponseEntity&lt;byte[]&gt;</span>&nbsp;<span class="element-name">getDatabaseFile</span><wbr><span class="parameters">(@PathVariable
 <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;id)</span></div>
<div class="block">Método que se encarga de obtener el archivo de la base de datos con el id proporcionado.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>id</code> - El id del archivo a obtener de la base de datos.</dd>
<dt>Returns:</dt>
<dd>ResponseEntity con el archivo obtenido y las cabeceras necesarias para la descarga del archivo.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="deleteFileDB(java.lang.String)">
<h3>deleteFileDB</h3>
<div class="member-signature"><span class="annotations">@DeleteMapping("/databasefiles/delete/{id}")
</span><span class="modifiers">public</span>&nbsp;<span class="return-type"><a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a></span>&nbsp;<span class="element-name">deleteFileDB</span><wbr><span class="parameters">(@PathVariable
 <a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/lang/String.html" title="class or interface in java.lang" class="external-link">String</a>&nbsp;id)</span></div>
<div class="block">Método que elimina un archivo de la base de datos a través de su identificador.</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>id</code> - El identificador del archivo a eliminar.</dd>
<dt>Returns:</dt>
<dd>La página de archivos después de eliminar el archivo.</dd>
</dl>
</section>
</li>
<li>
<section class="detail" id="handleStorageFileNotFound(java.io.FileNotFoundException)">
<h3>handleStorageFileNotFound</h3>
<div class="member-signature"><span class="annotations">@ExceptionHandler(<a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/io/FileNotFoundException.html" title="class or interface in java.io" class="external-link">java.io.FileNotFoundException.class</a>)
</span><span class="modifiers">public</span>&nbsp;<span class="return-type">org.springframework.http.ResponseEntity&lt;?&gt;</span>&nbsp;<span class="element-name">handleStorageFileNotFound</span><wbr><span class="parameters">(<a href="https://docs.oracle.com/en/java/javase/20/docs/api/java.base/java/io/FileNotFoundException.html" title="class or interface in java.io" class="external-link">FileNotFoundException</a>&nbsp;exc)</span></div>
<div class="block">Controlador de excepción para la excepción FileNotFoundException.
 Retorna una respuesta con un estado HTTP 404 (no encontrado).</div>
<dl class="notes">
<dt>Parameters:</dt>
<dd><code>exc</code> - la excepción FileNotFoundException que se ha producido</dd>
<dt>Returns:</dt>
<dd>ResponseEntity con un estado HTTP 404 (no encontrado)</dd>
</dl>
</section>
</li>
</ul>
</section>
</li>
</ul>
</section>
<!-- ========= END OF CLASS DATA ========= -->
</main>
</div>
</div>
</body>
</html>
